SystemOrganization addCategory: #'Sake-Tests'!

TestCase subclass: #SakeMetaTest
	instanceVariableNames: 'info'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sake-Tests'!

!SakeMetaTest methodsFor: 'as yet unclassified' stamp: 'kph 12/20/2007 14:27'!
setUp

	info := SakeMeta new.! !

!SakeMetaTest methodsFor: 'as yet unclassified' stamp: 'kph 10/1/2008 05:17'!
testKeyNotPresent

	self should: [ info test = nil ]
"
self debug: #testKeyNotPresent
"! !

!SakeMetaTest methodsFor: 'as yet unclassified' stamp: 'kph 12/20/2007 14:41'!
testSetter1

	self assert: (info class = SakeMeta).

	info test: 1.

	self assert: (1 = (info at: #test)).

	self assert: (info test = 1) 

"
self debug: #testSetter1
"! !

!SakeMetaTest methodsFor: 'as yet unclassified' stamp: 'kph 12/20/2007 14:46'!
testSetter2
 
	info test: 1 this: 2.

	self assert: (1 = (info at: #test)).
	self assert: (2 = (info at: #this)).

	self assert: (info test = 1).
	self assert: (info this = 2).
 ! !

!SakeMetaTest methodsFor: 'as yet unclassified' stamp: 'kph 12/20/2007 14:46'!
testSetter2b
 
	info test: 1; this: 2.

	self assert: (1 = (info at: #test)).
	self assert: (2 = (info at: #this)).

	self assert: (info test = 1).
	self assert: (info this = 2).
 ! !

TestCase subclass: #SakeTaskTest
	instanceVariableNames: 'trace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sake-Tests'!

SakeTaskTest subclass: #SakeClassTaskTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sake-Tests'!

!SakeClassTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:36'!
tearDown
	
	 (SakeClassTask remove: 'SakeTemp') run.	
 ! !

!SakeClassTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 22:37'!
testDependsOnExists
	
	
	| result |
	
	result := (SakeTask define: [ :task |
		
		task dependsOn: { (SakeTask class: 'Object') exists. (SakeClassTask exists: 'Object class'). }.
	
		task action: [ true ].

	]) run.

	self assert: result 
	! !

!SakeClassTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:36'!
testDependsOnExistsFails
	
	| it |

	it := SakeTask define: [ :task |
		
		task dependsOn: { (SakeTask class: 'ObjectNot') exists }.
	
		task action: [ true ].

	].

	self should: [ it run ] raise: SakeStop
	! !

!SakeClassTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 1/21/2009 14:45'!
testEnsureSubclass
	
	
	| result |
	
	result := (SakeTask define: [ :task |
		
		task dependsOn: { (SakeTask class: 'SakeClassTaskTest') subclass: 'SakeTemp' }.

		task action: [ true ].
			 
	]) run.

	self assert: result 
	
 ! !

!SakeClassTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:02'!
testExists

	self assert: [ (SakeTask class: 'Object') exists  run ].
	self assert: [ (SakeClassTask exists: 'Object')  run ].! !

SakeTaskTest subclass: #SakeFileTaskTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sake-Tests'!

!SakeFileTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 4/18/2008 01:56'!
shouldInheritSelectors

^ false! !

!SakeFileTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 1/21/2009 14:45'!
setUp

	'testDir' asDirectory all delete! !

!SakeFileTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 1/21/2009 15:00'!
testRuleFile

	(Smalltalk classNamed: 'FileKernel') isNil ifTrue: [ self fail ].

	self deny: ('testDir/test' asFile exists).

	SakeTaskTest ruleFile run.
	
	self assert: ('testDir/test' asFile contents = 'ruleFile').! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:38'!
ruleA

	^ SakeTask define: [ :task |
		
			task dependsOn: {self ruleB. self ruleC.}.
	     	task action: [ #ruleA ]
		
	  ]! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 12/23/2007 13:28'!
ruleASimpleExt: task

	task info extended: true.
	
	^ task! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:38'!
ruleB

	^ SakeTask define: [ :task |
		task dependsOn: {self ruleD.}.
	     task action: [ #ruleB ].
	]
		! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 1/21/2009 14:45'!
ruleBlock

	^ SakeTask action: [ 1 ]! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:38'!
ruleC

	^ SakeTask define: [ :task |
		task dependsOn: {self ruleD.}.
	     task action: [ #ruleC ].
	]
		! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:38'!
ruleD

	^ SakeTask define: [ :task |
		 
	     	task action: [ #ruleD ]
		
	  ]! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 10/1/2008 05:19'!
ruleDirectory

	^ (SakeTask file: 'testDir') in: [ :task |
		 
	     	task action: [ task target mkdir ]
		
	  ]
 ! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:38'!
ruleE: param

	^ SakeTask define: [ :task |
		 
	     	task action: [ task trace: param ]
		
	  ]! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 10/1/2008 05:20'!
ruleFile

	^ (SakeTask file: 'testDir/test') in: [ :task |
		 
			task dependsOn: { self ruleDirectory }.
	     	task action: [ task target contents: 'ruleFile' ]
		
	  ]
 ! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:39'!
ruleIfClassDoesntExist

	^ SakeTask define: [ :task |
		 
			task dependsOn: { Class exists: #Henry}.
	     	task action: [ task trace: 'Task Performed'. 'ok'.]
	  ]! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:39'!
ruleIfClassExists

	^ SakeTask define: [ :task |
		 
			task dependsOn: { Class exists: #Object}.
	     	task action: [ task trace: 'exists'. 'ok'. ]
	  ]
"
self ruleIfClassDoesntExist run

self ruleIfClassExists run
"! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:39'!
ruleL1

	^ SakeTask define: [ :task |
		 	task dependsOn: {self ruleL3.}.
	     	task action: [ task trace: #ruleL1 ]
	  ]! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:39'!
ruleL2

	^ SakeTask define: [ :task |
		task dependsOn: {self ruleL1.}.
	     task action: [ task trace: #ruleL2 ].
	]
		! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:39'!
ruleL3

	^ SakeTask define: [ :task |
		task dependsOn: {self ruleL2.}.
	     task action: [ task trace: #ruleL3 ].
	]
		! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:39'!
rulePA: param

	^ SakeTask define: [ :task |
		
			task dependsOn: {self rulePB: param. self rulePC: param.}.
	     	task action: [ param reverse ]
		
	  ]! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:39'!
rulePB: param

	^ SakeTask define: [ :task |
		task dependsOn: {self rulePD: param.}.
	     task action: [ ].
	]
		! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:39'!
rulePC: param

	^ SakeTask define: [ :task |
		task dependsOn: {self rulePD: param.}.
	     task action: [  ].
	]
		! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:39'!
rulePD: param

	^ SakeTask define: [ :task |
		 
	     	task action: [  ]
		
	  ]! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 10/1/2008 05:29'!
ruleReturnPriorTaskResults

	^ SakeTask define: [ :task |
			
			task dependsOn: { self ruleD. }.		 
	     	task action: [ :priorTasks | priorTasks collect: #result ]
		
	  ]! !

!SakeTaskTest class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 21:40'!
ruleTestBlock: param

	^ SakeTask define: [ :task |

			task dependsOn: { [ param isInteger ]. }.		 
	     	task action: [ true ]
		
	  ]! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 12/23/2007 23:50'!
fixtureBlocks

	| a b |
	a := [1].
	b := [1].
	
 ^ Array with: a with: b! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 10/1/2008 05:34'!
lookupDoubleAction: aValue

	^ aValue * 2! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 10/1/2008 05:37'!
lookupSomeValue: aTask

	^ aTask! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 10/1/2008 04:45'!
runCaseWith: aBlock

	"this method provides a place for subclasses to override in order to enclose running of test cases
	within a testing context	e.g. PRCurrentContext value: self context during: aBlock"
	
	trace := OrderedCollection new.

	SakeSignal context: self during: aBlock 
 
     ! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 12/23/2007 23:51'!
testBlockEquality

	self assert: (self fixtureBlocks = self fixtureBlocks).
	self deny: (self fixtureBlocks first = self fixtureBlocks second).! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 1/1/2008 01:39'!
testClassDoesNotExist
  	
	self should: [ self class ruleIfClassDoesntExist run ] raise: SakeStop.
	self assert: (trace first = 'Class class>>exists:').
	self assert: (trace size = 1).! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 12/31/2007 22:56'!
testClassExists
  	
	self assert: ('ok' = self class ruleIfClassExists run).
	self assert: ('exists' = trace third).! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 10/1/2008 05:38'!
testContext

	"tasks can run within a context, here the context is self, so #lookupDoubleAction is performed with: 2"

	self assert: ((SakeTask noop lookup: #lookupDoubleAction: with: 2) = 4).

	"if no arg is supplied the task is fed in"
	self assert: ((SakeTask noop lookup: #lookupSomeValue: ) = SakeTask noop).
	 ! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 12/31/2007 22:50'!
testDependancyABCD

	(SakeTaskTest ruleA) run.  
	self assert: ('SakeTaskTest class>>ruleD' = trace first).
	self assert: (#('SakeTaskTest class>>ruleB' 'SakeTaskTest class>>ruleC') includes: trace second).
	self assert: (#('SakeTaskTest class>>ruleB' 'SakeTaskTest class>>ruleC') includes: trace third).
	self assert: ('SakeTaskTest class>>ruleA' = trace fourth).
! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 12/31/2007 22:49'!
testDependancyABCDWithParams

	| result |
	
	result := (SakeTaskTest rulePA: 'abcd') run.  
 
	self assert: (result = 'dcba').

	self assert: ('SakeTaskTest class>>rulePD:' = trace first).
	self assert: (#('SakeTaskTest class>>rulePB:' 'SakeTaskTest class>>rulePC:') includes: trace second).
	self assert: (#('SakeTaskTest class>>rulePB:' 'SakeTaskTest class>>rulePC:') includes: trace third).
	self assert: ('SakeTaskTest class>>rulePA:' = trace fourth).
! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 12/23/2007 21:15'!
testDependancyBlock

	| result |
	
	result := (SakeTaskTest ruleTestBlock: 1) run.  
 
	self assert: (result = true).

! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 12/23/2007 04:29'!
testDependancyLoop

	self should: [ SakeTaskTest ruleL1 ] raise: Error.
! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 10/1/2008 05:29'!
testDependentsResults
	"does not work with non Rake ordering".
	self assert: (SakeTaskTest ruleReturnPriorTaskResults run = #( ruleD )).
! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 12/22/2007 13:54'!
testEquality
 
	self assert: (SakeTask noop = SakeTask noop).
	self assert: (SakeTaskTest ruleA = SakeTaskTest ruleA).
	self deny: (SakeTaskTest ruleA = SakeTaskTest ruleB).
	
	! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 12/23/2007 21:56'!
testEqualityOfBlockRule
  	self assert: ((SakeTaskTest ruleBlock) = (SakeTaskTest ruleBlock)).
  	self deny: ((SakeTaskTest ruleE: 'A') = (SakeTaskTest ruleE: 'B')).
	
	! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 12/23/2007 15:01'!
testEqualityOfRuleWithParam
  	self assert: ((SakeTaskTest ruleE: 'A') = (SakeTaskTest ruleE: 'A')).
  	self deny: ((SakeTaskTest ruleE: 'A') = (SakeTaskTest ruleE: 'B')).
	
	! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 12/22/2007 15:18'!
testExtensions

	self assert: (SakeTaskTest ruleA withExtensions info extended).
	! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 1/21/2009 15:10'!
testNot

	self should: [  (SakeTaskTest ruleIfClassExists not) run ] raise: SakeStop.
	self should: [  (SakeTaskTest ruleIfClassDoesntExist not) run ]
! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 1/1/2008 03:09'!
testReturnActionResult

	self assert: (#ruleD == (SakeTaskTest ruleD) run)
! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 1/1/2008 03:10'!
testReturnAlreadyRun

	| task |
	
	task := SakeTaskTest ruleD.

	task run.
	
	self assert: (task hasRun).
	
	self assert: (task run = #ruleD).! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 10/1/2008 05:05'!
traceAction: aMessage

	self log sake <<< (trace add: aMessage). 
	 ! !

!SakeTaskTest methodsFor: 'as yet unclassified' stamp: 'kph 12/21/2007 12:48'!
traceKeys

	^ trace collect: [ :ea | ea key ]! !
